#define NAMESTR "sincost.c"
#define ZSGN(a) (((a)<0) ? -1 : (a)>0 ? 1 : 0)
#include <stdio.h>
#include <math.h>
/* generate sin table */
int main () {
  FILE *handleP;
  int x;
  double dummy;
  double dval;
  int value;
  handleP=fopen (NAMESTR,"wt");
  fprintf (handleP,"typedef signed int TrigTabType [360];\n"
                   "TrigTabType SinTab={"
                   );
  for (x=0;x<=359;x++) {
    if ((x) % 10==0) fprintf (handleP,"\n");
    dval =(sin (x * M_PI/180)*255);
    printf ("x: %i, dval: %f",x,dval);
    if (fabs (modf (dval,&dummy))<0.5)
      value=(signed int)dval;
    else {
      value=(signed int)dval+ZSGN (dval);
      printf ("%i",ZSGN (dval));
    }
    printf (" rouded to: %i\n",value);
    fprintf (handleP,"%i,",value);
  }
  fprintf (handleP,"};\n");
  fprintf (handleP,"TrigTabType CosTab={");
  for (x=0;x<=359;x++) {
    if ((x) % 10==0) fprintf (handleP,"\n");
    dval =(cos (x * M_PI/180)*255);
    printf ("x: %i, dval: %f",x,dval);
    if (fabs (modf (dval,&dummy))<0.5)
      value=(signed int)dval;
    else {
      value=(signed int)dval+ZSGN (dval);
      printf ("%i",ZSGN (dval));
    }
    printf (" rouded to: %i\n",value);
    fprintf (handleP,"%i,",value);
  }
  fprintf (handleP,"};");
  fclose (handleP);
  return 0;
}